/*=====================================================================
File: AppellationColumn.cs

Summary: 

Date : Septembre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;
using OpenCellar.Framework.Core;

namespace OpenCellar.Import.Framework
{
    public class AppellationColumn : Column
    {
        /// <summary>
        /// Initialise une instance de classe AppellationColumn.
        /// </summary>
        public AppellationColumn()
            : base(Res.COL_WINE_APPELLATION)
        { 
            
        }

        public override bool Process(OpenCellar.Framework.Core.Wine wine, IRow row)
        {
            // Vrifie l'indice de la colonne.
            if (!row.CheckIndice(Index))
            { 
                return (false);
            }


            wine.Appellation = (OpenCellar.Framework.Core.Name)OCUtility.CreateBaseItem(wine.Cellar, ObjectType.Name, row[Index]);
               
            return (true);
        }

        // <summary>
        /// Cre une copie de la colonne.
        /// </summary>
        /// <returns></returns>
        public override IColumn Clone()
        {
            return (new AppellationColumn());
        }
    }
}
