/*=====================================================================
File: BuyPriceColumn.cs

Summary: 

Date : Septembre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;
using System.Text;

namespace OpenCellar.Import.Framework
{
	/// <summary>
	/// BuyPriceColumn.
	/// </summary>
    public sealed class BuyPriceColumn : Column
    {
        /// <summary>
        /// Initialise une instance de classe BuyPriceColumn.
        /// </summary>
        public BuyPriceColumn()
            : base(Res.COL_WINE_BUY_PRICE)
        { 
            
        }

        public override bool Process(OpenCellar.Framework.Core.Wine wine, IRow row)
        {
            // Vrifie l'indice de la colonne.
            if (!row.CheckIndice(Index))
            { 
                return (false);
            }

            bool success = false;

            wine.BuyPrice = OCUtility.TryParseFloat(row[Index], out success);
               
            return (success);
        }


        // <summary>
        /// Cre une copie de la colonne.
        /// </summary>
        /// <returns></returns>
        public override IColumn Clone()
        {
            return (new BuyPriceColumn());
        }
    }
}
