/*=====================================================================
File: CepageColumn.cs

Summary: 

Date : Septembre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;
using OpenCellar.Framework.Core;

namespace OpenCellar.Import.Framework
{
    public class CepageColumn : Column
    {
        /// <summary>
        /// Initialise une instance de classe CepageColumn.
        /// </summary>
        public CepageColumn()
            : base(Res.COL_WINE_CEPAGE)
        { 
            
        }

        public override bool Process(OpenCellar.Framework.Core.Wine wine, IRow row)
        {
            // Vrifie l'indice de la colonne.
            if (!row.CheckIndice(Index))
            { 
                return (false);
            }

            wine.Cepage = (TypeOfWine)OCUtility.CreateBaseItem(wine.Cellar, ObjectType.TypeOfWine, row[Index]);
               
            return (true);
        }

        // <summary>
        /// Cre une copie de la colonne.
        /// </summary>
        /// <returns></returns>
        public override IColumn Clone()
        {
            return (new CepageColumn());
        }
    }
}
