/*=====================================================================
File: ClassificationColumn.cs

Summary: 

Date : Septembre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;
using OpenCellar.Framework.Core;

namespace OpenCellar.Import.Framework
{
    public class ClassificationColumn : Column
    {
        /// <summary>
        /// Initialise une instance de classe ClassificationColumn.
        /// </summary>
        public ClassificationColumn()
            : base(Res.COL_WINE_CLASSIFICATION)
        { 
            
        }

        public override bool Process(OpenCellar.Framework.Core.Wine wine, IRow row)
        {
            // Vrifie l'indice de la colonne.
            if (!row.CheckIndice(Index))
            { 
                return (false);
            }

            wine.Classification = (Classification)OCUtility.CreateBaseItem(wine.Cellar, ObjectType.Classification, row[Index]);
               
            return (true);
        }

        // <summary>
        /// Cre une copie de la colonne.
        /// </summary>
        /// <returns></returns>
        public override IColumn Clone()
        {
            return (new ClassificationColumn());
        }
    }
}
