/*=====================================================================
File: ColorColumn.cs

Summary: 

Date : Septembre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;
using System.Collections;
using OpenCellar.Framework.Core;

namespace OpenCellar.Import.Framework
{
	/// <summary>
	/// ColorColumn.
	/// </summary>
    public class ColorColumn : Column
    {
		static Hashtable colorsTable = new Hashtable();

		static ColorColumn()
		{
			colorsTable.Add("rouge", ColorType.Red);
			colorsTable.Add("vin rouge", ColorType.Red);
			colorsTable.Add("vins rouge", ColorType.Red);
			colorsTable.Add("blanc", ColorType.White);
			colorsTable.Add("vins blanc", ColorType.White);
			colorsTable.Add("vin blanc", ColorType.White);
			colorsTable.Add("ros", ColorType.Rosy);
			colorsTable.Add("vins ros", ColorType.Rosy);
			colorsTable.Add("vin ros", ColorType.Rosy);
			colorsTable.Add("rose", ColorType.Rosy);
			colorsTable.Add("champagne", ColorType.Yellow);
			colorsTable.Add("mousseux", ColorType.Yellow);
			colorsTable.Add("ptillant", ColorType.Yellow);			
			colorsTable.Add("petillant", ColorType.Yellow);
			colorsTable.Add("autres", ColorType.Misc);
			colorsTable.Add("moelleux", ColorType.LiqueurLike);
			colorsTable.Add("liquoreux", ColorType.LiqueurLike);
		}

        /// <summary>
        /// Initialise une instance de classe ColorColumn.
        /// </summary>
        public ColorColumn()
            : base(Res.COL_WINE_COLOR)
        { 
            
        }

        public override bool Process(OpenCellar.Framework.Core.Wine wine, IRow row)
        {
            // Vrifie l'indice de la colonne.
            if (!row.CheckIndice(Index))
            { 
                return (false);
            }

			ColorType ct = ColorType.Red;
			string colorString = row[Index].ToLower();

			if(ColorColumn.colorsTable.ContainsKey(colorString))
			{
				ct = (ColorType)ColorColumn.colorsTable[colorString];
			}

            wine.WineColor = ct;
               
            return (true);
        }

        // <summary>
        /// Cre une copie de la colonne.
        /// </summary>
        /// <returns></returns>
        public override IColumn Clone()
        {
            return (new ColorColumn());
        }
    }
}
