/*=====================================================================
File: CommentColumn.cs

Summary: 

Date : Septembre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;
using System.Text;

namespace OpenCellar.Import.Framework
{
	/// <summary>
	/// CommentColumn.
	/// </summary>
    public sealed class CommentColumn : Column
    {
        /// <summary>
        /// Initialise une instance de classe CommentColumn.
        /// </summary>
        public CommentColumn()
            : base(Res.COL_WINE_COMMENT)
        { 
            
        }

        public override bool Process(OpenCellar.Framework.Core.Wine wine, IRow row)
        {
            // Vrifie l'indice de la colonne.
            if (!row.CheckIndice(Index))
            { 
                return (false);
            }

            wine.Comment = row[Index];
               
            return (true);
        }

        // <summary>
        /// Cre une copie de la colonne.
        /// </summary>
        /// <returns></returns>
        public override IColumn Clone()
        {
            return (new CommentColumn());
        }
    }
}
