/*=====================================================================
File: CountryColumn.cs

Summary: 

Date : Septembre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;
using OpenCellar.Framework.Core;

namespace OpenCellar.Import.Framework
{
    public class CountryColumn : Column
    {
        /// <summary>
        /// Initialise une instance de classe CountryColumn.
        /// </summary>
        public CountryColumn()
            : base(Res.COL_WINE_COUNTRY)
        { 
            
        }

        public override bool Process(OpenCellar.Framework.Core.Wine wine, IRow row)
        {
            // Vrifie l'indice de la colonne.
            if (!row.CheckIndice(Index))
            { 
                return (false);
            }


            wine.Country = (Country)OCUtility.CreateBaseItem(wine.Cellar, ObjectType.Country, row[Index]);
               
            return (true);
        }

        // <summary>
        /// Cre une copie de la colonne.
        /// </summary>
        /// <returns></returns>
        public override IColumn Clone()
        {
            return (new CountryColumn());
        }
    }
}
