/*=====================================================================
File: ReferenceColumn.cs

Summary: 

Date : Septembre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;
using System.Text;

namespace OpenCellar.Import.Framework
{
	/// <summary>
	/// CuveeColumn.
	/// </summary>
    public sealed class CuveeColumn : Column
    {
        /// <summary>
        /// Initialise une instance de classe CuveeColumn.
        /// </summary>
        public CuveeColumn()
            : base(Res.COL_WINE_CUVEE)
        { 
            
        }

        public override bool Process(OpenCellar.Framework.Core.Wine wine, IRow row)
        {
            // Vrifie l'indice de la colonne.
            if (!row.CheckIndice(Index))
            { 
                return (false);
            }

            wine.Cuvee = row[Index];
               
            return (true);
        }

        // <summary>
        /// Cre une copie de la colonne.
        /// </summary>
        /// <returns></returns>
        public override IColumn Clone()
        {
            return (new CuveeColumn());
        }
    }
}
