/*=====================================================================
File: GeneralNoteColumn.cs

Summary: 

Date : Septembre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;
using System.Text;

namespace OpenCellar.Import.Framework
{
	/// <summary>
	/// GeneralNoteColumn.
	/// </summary>
    public sealed class GeneralNoteColumn : Column
    {
        /// <summary>
        /// Initialise une instance de classe GeneralNoteColumn.
        /// </summary>
        public GeneralNoteColumn()
            : base(Res.COL_WINE_GENERAL_NOTE)
        { 
            
        }

        public override bool Process(OpenCellar.Framework.Core.Wine wine, IRow row)
        {
            // Vrifie l'indice de la colonne.
            if (!row.CheckIndice(Index))
            { 
                return (false);
            }

			bool success = false;

			byte note = OCUtility.TryParseByte(row[Index], out success);

			if(note < 6)
			{
				wine.GeneralNote = note;
			}
			else
			{
				success = false;
			}
               
			return (success);
        }

        // <summary>
        /// Cre une copie de la colonne.
        /// </summary>
        /// <returns></returns>
        public override IColumn Clone()
        {
            return (new GeneralNoteColumn());
        }
    }
}
