using System;
using System.Text;

namespace OpenCellar.Import.Framework
{
    public sealed class NameColumn : Column
    {
        /// <summary>
        /// Initialise une instance de classe NameColumn.
        /// </summary>
        public NameColumn()
            : base(Res.COL_WINE_NAME)
        { 
            
        }

        public override bool Process(OpenCellar.Framework.Core.Wine wine, IRow row)
        {
            // Vrifie l'indice de la colonne.
            if (!row.CheckIndice(Index))
            { 
                return (false);
            }

            wine.Name = row[Index];
               
            return (true);
        }

        // <summary>
        /// Cre une copie de la colonne.
        /// </summary>
        /// <returns></returns>
        public override IColumn Clone()
        {
            return (new NameColumn());
        }
    }
}
