/*=====================================================================
File: OwnerCityColumn.cs

Summary: 

Date : Septembre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;
using OpenCellar.Framework.Core;

namespace OpenCellar.Import.Framework
{
	/// <summary>
	/// OwnerCityColumn
	/// </summary>
    public class OwnerCityColumn : Column
    {
        /// <summary>
        /// Initialise une instance de classe OwnerCityColumn.
        /// </summary>
        public OwnerCityColumn()
            : base(Res.COL_WINE_OWNER_CITY)
        { 
            
        }

        public override bool Process(OpenCellar.Framework.Core.Wine wine, IRow row)
        {
            // Vrifie l'indice de la colonne.
            if (!row.CheckIndice(Index))
            { 
                return (false);
            }

			Owner o = wine.Owner;

			if((o.SystemUID != OpenCellar.Framework.Core.Constants.EMPTY_UID)
				&& (o.City != row[Index]))
			{
				o.City = row[Index];
				o.Save();
			}
               
            return (true);
        }

        // <summary>
        /// Cre une copie de la colonne.
        /// </summary>
        /// <returns></returns>
        public override IColumn Clone()
        {
            return (new OwnerCityColumn());
        }
    }
}
