/*=====================================================================
File: OwnerNameColumn.cs

Summary: 

Date : Septembre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;
using OpenCellar.Framework.Core;

namespace OpenCellar.Import.Framework
{
	/// <summary>
	/// OwnerNameColumn
	/// </summary>
    public class OwnerNameColumn : Column
    {
        /// <summary>
        /// Initialise une instance de classe OwnerNameColumn.
        /// </summary>
        public OwnerNameColumn()
            : base(Res.COL_WINE_OWNER_NAME, 100)
        { 
        }

        public override bool Process(OpenCellar.Framework.Core.Wine wine, IRow row)
        {
            // Vrifie l'indice de la colonne.
            if (!row.CheckIndice(Index))
            { 
                return (false);
            }

			
            wine.Owner = (Owner)OCUtility.CreateContact(wine.Cellar, ObjectType.Owner, row[Index]);
               
            return (true);
        }

        // <summary>
        /// Cre une copie de la colonne.
        /// </summary>
        /// <returns></returns>
        public override IColumn Clone()
        {
            return (new OwnerNameColumn());
        }
    }
}
