/*=====================================================================
File: PurchaseCommentColumn.cs

Summary: 

Date : Septembre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;
using OpenCellar.Framework.Core;

namespace OpenCellar.Import.Framework
{
	/// <summary>
	/// PurchaseCommentColumn
	/// </summary>
    public class PurchaseCommentColumn : Column
    {
        /// <summary>
        /// Initialise une instance de classe PurchaseCommentColumn.
        /// </summary>
        public PurchaseCommentColumn()
            : base(Res.COL_WINE_PURCHASE_COMMENT)
        { 
        }

        public override bool Process(OpenCellar.Framework.Core.Wine wine, IRow row)
        {
            // Vrifie l'indice de la colonne.
            if (!row.CheckIndice(Index))
            { 
                return (false);
            }

			if(row[Index] == string.Empty)
			{
				return(true);
			}

			bool success = false;
			// File d'attente
			if(wine.PurchaseWorkqueue.Count == 0)
			{
				PurchaseSales ps = (PurchaseSales)wine.Cellar.CreateItem(ObjectType.PurchaseSales);
				ps.Comment = row[Index];
				wine.PurchaseWorkqueue.Set(WorkqueueItemType.Add, ps);
			}
			else
			{
				wine.PurchaseWorkqueue[0].Item.Comment = row[Index];
			}
               
            return (success);
        }

        // <summary>
        /// Cre une copie de la colonne.
        /// </summary>
        /// <returns></returns>
        public override IColumn Clone()
        {
            return (new PurchaseCommentColumn());
        }
    }
}
