/*=====================================================================
File: PurchaseProviderAddress2Column.cs

Summary: 

Date : Septembre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;
using OpenCellar.Framework.Core;

namespace OpenCellar.Import.Framework
{
	/// <summary>
	/// PurchaseProviderAddress2Column
	/// </summary>
    public class PurchaseProviderAddress2Column : Column
    {
        /// <summary>
        /// Initialise une instance de classe PurchaseProviderAddress2Column.
        /// </summary>
        public PurchaseProviderAddress2Column()
            : base(Res.COL_WINE_PURCHASE_PROVIDER_ADDRESS2)
        { 
            
        }

        public override bool Process(OpenCellar.Framework.Core.Wine wine, IRow row)
        {
            // Vrifie l'indice de la colonne.
            if (!row.CheckIndice(Index))
            { 
                return (false);
            }

			if(row[Index] == string.Empty)
			{
				return(true);
			}

			Provider provider = null;

			// File d'attente
			if(wine.PurchaseWorkqueue.Count > 0)
			{
				provider = wine.PurchaseWorkqueue[0].Item.Provider;
			}
			
			if((provider != null)
				&& (provider.SystemUID != OpenCellar.Framework.Core.Constants.EMPTY_UID))
			{
				// OK
				provider.Address2 = row[Index];
				provider.Save();
			}
              
            return (true);
        }

        // <summary>
        /// Cre une copie de la colonne.
        /// </summary>
        /// <returns></returns>
        public override IColumn Clone()
        {
            return (new PurchaseProviderAddress2Column());
        }
    }
}
