/*=====================================================================
File: PurchaseProviderNameColumn.cs

Summary: 

Date : Septembre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;
using OpenCellar.Framework.Core;

namespace OpenCellar.Import.Framework
{
	/// <summary>
	/// PurchaseProviderNameColumn
	/// </summary>
    public class PurchaseProviderNameColumn : Column
    {
        /// <summary>
        /// Initialise une instance de classe PurchaseProviderNameColumn.
        /// </summary>
        public PurchaseProviderNameColumn()
            : base(Res.COL_WINE_PURCHASE_PROVIDER_NAME, 100)
        { 
        }

        public override bool Process(OpenCellar.Framework.Core.Wine wine, IRow row)
        {
            // Vrifie l'indice de la colonne.
            if (!row.CheckIndice(Index))
            { 
                return (false);
            }

			if(row[Index] == string.Empty)
			{
				return(true);
			}

			// File d'attente
			if(wine.PurchaseWorkqueue.Count > 0)
			{
				wine.PurchaseWorkqueue[0].Item.Provider = (Provider)OCUtility.CreateContact(wine.Cellar, ObjectType.Provider, row[Index]);	
			}
			else
			{
				PurchaseSales ps = (PurchaseSales)wine.Cellar.CreateItem(ObjectType.PurchaseSales);
				ps.Provider = (Provider)OCUtility.CreateContact(wine.Cellar, ObjectType.Provider, row[Index]);	
				wine.PurchaseWorkqueue.Set(WorkqueueItemType.Add, ps);
			}           
               
            return (true);
        }

        // <summary>
        /// Cre une copie de la colonne.
        /// </summary>
        /// <returns></returns>
        public override IColumn Clone()
        {
            return (new PurchaseProviderNameColumn());
        }
    }
}
