/*=====================================================================
File: RackColumn.cs

Summary: 

Date : Octobre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;
using System.Text;
using OpenCellar.Framework.Core;

namespace OpenCellar.Import.Framework
{
	/// <summary>
	/// RackColumn.
	/// </summary>
    public sealed class RackColumn : Column
    {
        /// <summary>
        /// Initialise une instance de classe RackColumn.
        /// </summary>
        public RackColumn()
            : base(Res.COL_WINE_RACK, 100)
        { 
            
        }

        public override bool Process(OpenCellar.Framework.Core.Wine wine, IRow row)
        {
            // Vrifie l'indice de la colonne.
            if (!row.CheckIndice(Index))
            { 
                return (false);
            }

			if(row[Index] == string.Empty)
			{
				return(false);
			}


			string compareValue = row[Index].Trim().ToLower();

			bool find = false;

			ObjectCollection racks = wine.Cellar.GetCollection((ushort)ObjectType.Rack);
			for (int i = 0 ; i <  racks.Count; i++)
			{
				string name = ((Rack)racks[i]).Name.Trim().ToLower();

				if(name == compareValue)
				{
					find = true;
					break;
				}
			}

			// Si l'emplacement n'est pas trouv on le cre
			if(!find)
			{
				RackBuilder builder = new RackBuilder(wine.Cellar);
				builder.SetRackName(row[Index]);
				builder.SetRowsSize(0);
				builder.SetColumnsSize(0);
				builder.Save();
				builder.Close();
			}

              
            return (true);
        }

        // <summary>
        /// Cre une copie de la colonne.
        /// </summary>
        /// <returns></returns>
        public override IColumn Clone()
        {
            return (new RackColumn());
        }
    }
}
