/*=====================================================================
File: AccessWindowsFactory.cs

Summary: 

Date : Septembre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;

namespace OpenCellar.Import.Framework
{
	/// <summary>
	/// AccessWindowsFactory.
	/// </summary>
	public class AccessWindowsFactory : IWindowsDocumentFactory
	{
		/// <summary>
		/// Intialise une instance de classe AccessWindowsFactory.
		/// </summary>
		public AccessWindowsFactory(){}
		
		public IDocument CreateDocument(OpenCellar.Framework.Core.Cellar cellar)
		{
			IDocument document = null;

			// Vrifie le mode windows.
			if(!Environment.UserInteractive)
			{
				throw new ApplicationException("AccessWindowsFactory::Environment.UserInteractive = false");
			}

			// Affiche la boite de proprits
			using(Layer.AccessLayer layer = new OpenCellar.Import.Framework.Layer.AccessLayer())
			{
				if(layer.ShowDialog() == System.Windows.Forms.DialogResult.OK)
				{
					// Construit la chaine de connexion
					document = new AccessDocument(cellar, layer.ConnectionString, layer.Sql);
				}
			}

			return(document);
		}

		/// <summary>
		/// Renvoit le nom de la fabrique.
		/// </summary>
		/// <returns></returns>
		public string GetName()
		{
			return(Res.ACCESS_FACTORY);
		}

		public override string ToString()
		{
			return(GetName());
		}

	}
}
