/*=====================================================================
File: CSVWindowsFactory.cs

Summary: 

Date : Septembre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;

namespace OpenCellar.Import.Framework
{
	/// <summary>
	/// CSVWindowsFactory.
	/// </summary>
	public class CSVWindowsFactory : IWindowsDocumentFactory
	{
		/// <summary>
		/// Intialise une instance de classe CSVWindowsFactory.
		/// </summary>
		public CSVWindowsFactory(){}
		
		public IDocument CreateDocument(OpenCellar.Framework.Core.Cellar cellar)
		{
			IDocument document = null;

			// Vrifie le mode windows.
			if(!Environment.UserInteractive)
			{
				throw new ApplicationException("CSVWindowsFactory::Environment.UserInteractive = false");
			}

			// Affiche la boite de proprits
			using(Layer.CSVLayer layer = new OpenCellar.Import.Framework.Layer.CSVLayer())
			{
				if(layer.ShowDialog() == System.Windows.Forms.DialogResult.OK)
				{
					document = new CSVDocument(cellar, layer.CSVFilePath);
					((CSVDocument)document).Separator = layer.Separator;
				}
			}

			return(document);
		}

		/// <summary>
		/// Renvoit le nom de la fabrique.
		/// </summary>
		/// <returns></returns>
		public string GetName()
		{
			return(Res.CSV_FACTORY);
		}

		public override string ToString()
		{
			return(GetName());
		}

	}
}
