/*=====================================================================
File: IDBRow.cs

Summary: 

Date : Septembre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;
using System.Collections.Specialized;
using System.Text;
using System.Data;

namespace OpenCellar.Import.Framework
{
	/// <summary>
	/// IDBRow
	/// </summary>
    public class IDBRow : Row
    {
        /// <summary>
        /// Initialise une instance de classe CSVRow.
        /// </summary>
        /// <param name="parent">Document parent;</param>
        /// <param name="rowIndex">Index de la ligne.</param>
        /// <param name="line">Ligne a analyser</param>
        internal protected IDBRow(IDBDocument parent,
            int rowIndex,
            IDataReader reader)
            : base(parent, rowIndex)
        {
            this.__parse(reader);
        }

        /// <summary>
        /// Analyse le recordset.
        /// </summary>
        private void __parse(IDataReader reader)
        {
            if (reader == null)
            {
                throw new ArgumentNullException("reader");
            }

			int fields = reader.FieldCount;

			for (int i = 0; i < fields; i++)
			{
				object value = reader[i];

				if((value == null)
					| (value == DBNull.Value))
				{
					base.Add(string.Empty);
				}
				else
				{
					base.Add(reader[i].ToString());
				}
			}
        }        
    }
}
