/*=====================================================================
File: OleDBDocument.cs

Summary: 

Date : Septembre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;
using System.Data;
using System.Data.OleDb;
using System.Text;
using OpenCellar.Framework.Core;

namespace OpenCellar.Import.Framework
{
	/// <summary>
	/// OleDBDocument
	/// </summary>
    public class OleDBDocument : IDBDocument
    {
        /// <summary>
        /// Initialise une instance de classe OleDBDocument.
        /// </summary>
        /// <param name="cellar"></param>
        /// <param name="commandText">Requete de selection.</param>
        /// <param name="connectionString">Chaine de connexion.</param>
        public OleDBDocument(Cellar cellar, string connectionString, string commandText)
            : base(cellar, connectionString, commandText)
        { 
			
        }

		protected override IDbConnection CreateConnection()
		{
			IDbConnection oleDbConnection = null;
			
			try
			{
				oleDbConnection = new OleDbConnection(this.ConnectionString);
				oleDbConnection.Open();
			}
			catch
			{
				// ZzZzz
			}

			return(oleDbConnection);
		}
    }
}
