/*=====================================================================
File: AccessLayer.cs

Summary: 

Date : Septembre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;
using System.Data;
using System.Data.OleDb;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace OpenCellar.Import.Framework.Layer
{
	/// <summary>
	/// AccessLayer.
	/// </summary>
	public class AccessLayer : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button cancelButton;
		private System.Windows.Forms.Button okButton;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox accessFilePath;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox sql;
		private System.Windows.Forms.Button test;
		/// <summary>
		/// Variable ncessaire au concepteur.
		/// </summary>
		private System.ComponentModel.Container components = null;

		/// <summary>
		/// Initialise une instance de classe CSVLayer.
		/// </summary>
		public AccessLayer()
		{
			//
			// Requis pour la prise en charge du Concepteur Windows Forms
			//
			InitializeComponent();

			this.Location = this.PointToClient(MousePosition);
			Control line = new Control();
			line.Location = new Point(0, cancelButton.Top - 12);
			line.Size = new Size(this.Width, 1);
			line.BackColor = Color.Black;
			Controls.Add(line);
		}

		/// <summary>
		/// Obtient l'emplacement du fichier access.
		/// </summary>
		public string AccessFilePath
		{
			get
			{
				return(accessFilePath.Text);
			}
		}

		public string ConnectionString
		{
			get
			{
				return(@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + this.AccessFilePath + ";");
			}
		}

		/// <summary>
		/// Obtient la requete d'execution.
		/// </summary>
		public string Sql
		{
			get
			{
				return(sql.Text);
			}
		}

		/// <summary>
		/// Obtient si les informations saisies sont correctes.
		/// </summary>
		private bool IsValid
		{
			get
			{
				
				if(!System.IO.File.Exists(this.AccessFilePath))
				{
					return(false);
				}

				bool success = false;
				TestConnection(out success, false);
				return(success);
			}
		}

		/// <summary>
		/// Nettoyage des ressources utilises.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Code gnr par le Concepteur Windows Form
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		private void InitializeComponent()
		{
			this.cancelButton = new System.Windows.Forms.Button();
			this.okButton = new System.Windows.Forms.Button();
			this.accessFilePath = new System.Windows.Forms.TextBox();
			this.button1 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.sql = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.test = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// cancelButton
			// 
			this.cancelButton.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.cancelButton.Location = new System.Drawing.Point(272, 192);
			this.cancelButton.Name = "cancelButton";
			this.cancelButton.TabIndex = 9;
			this.cancelButton.Text = "Annuler";
			this.cancelButton.Click += new System.EventHandler(this.cancelButton_Click);
			// 
			// okButton
			// 
			this.okButton.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.okButton.Location = new System.Drawing.Point(176, 192);
			this.okButton.Name = "okButton";
			this.okButton.TabIndex = 7;
			this.okButton.Text = "OK";
			this.okButton.Click += new System.EventHandler(this.okButton_Click);
			// 
			// accessFilePath
			// 
			this.accessFilePath.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.accessFilePath.Location = new System.Drawing.Point(8, 40);
			this.accessFilePath.Name = "accessFilePath";
			this.accessFilePath.Size = new System.Drawing.Size(232, 21);
			this.accessFilePath.TabIndex = 1;
			this.accessFilePath.Text = "";
			// 
			// button1
			// 
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button1.Location = new System.Drawing.Point(256, 40);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(88, 23);
			this.button1.TabIndex = 3;
			this.button1.Text = "Parcourir...";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(320, 23);
			this.label1.TabIndex = 6;
			this.label1.Text = "Indiquer l\'emplacement de la base Access";
			// 
			// sql
			// 
			this.sql.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.sql.Location = new System.Drawing.Point(8, 104);
			this.sql.Multiline = true;
			this.sql.Name = "sql";
			this.sql.Size = new System.Drawing.Size(336, 64);
			this.sql.TabIndex = 4;
			this.sql.Text = "SELECT * FROM <TableName>";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 72);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(320, 23);
			this.label2.TabIndex = 11;
			this.label2.Text = "Indiquer la requete SQL";
			// 
			// test
			// 
			this.test.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.test.Location = new System.Drawing.Point(8, 192);
			this.test.Name = "test";
			this.test.Size = new System.Drawing.Size(88, 23);
			this.test.TabIndex = 5;
			this.test.Text = "Tester";
			this.test.Click += new System.EventHandler(this.test_Click);
			// 
			// AccessLayer
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.BackColor = System.Drawing.SystemColors.Control;
			this.ClientSize = new System.Drawing.Size(362, 224);
			this.Controls.Add(this.test);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.sql);
			this.Controls.Add(this.accessFilePath);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.okButton);
			this.Controls.Add(this.cancelButton);
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "AccessLayer";
			this.Text = "Configuration";
			this.Load += new System.EventHandler(this.AccessLayer_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void okButton_Click(object sender, System.EventArgs e)
		{
			if(IsValid)
			{
				this.DialogResult = DialogResult.OK;
			}
			else
			{
				MessageBox.Show(Res.UI_INVALID_ARGS, 
					"Open Cellar",
					MessageBoxButtons.OK,
					MessageBoxIcon.Warning);
			}
		}

		private void cancelButton_Click(object sender, System.EventArgs e)
		{
			this.DialogResult = DialogResult.Cancel;
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			// Affiche la boite parcourir.
			using(OpenFileDialog ofd = new OpenFileDialog())
			{
				ofd.Filter = "Fichiers Microsoft Access (*.mdb;*.accdb)|*.mdb;*.accdb";

				if(ofd.ShowDialog() == DialogResult.OK)
				{
					accessFilePath.Text = ofd.FileName;
				}
			}
		}

		private void AccessLayer_Load(object sender, System.EventArgs e)
		{
		
		}

		private void test_Click(object sender, System.EventArgs e)
		{
			bool success = false;
			TestConnection(out success, true);
		}

		private void TestConnection(out bool success, bool showMessage)
		{
			OleDbConnection connection = null;
			OleDbCommand command = null;
			try
			{
				connection = new OleDbConnection(this.ConnectionString);
				connection.Open();
				command = connection.CreateCommand();
				command.CommandText = this.Sql;
				command.ExecuteNonQuery();

				success = true;

				if(showMessage)
				{
					MessageBox.Show(Res.UI_SUCCESS_TEST,
						"Open Cellar",
						MessageBoxButtons.OK,
						MessageBoxIcon.Information);
				}
			}
			catch(Exception ex)
			{
				if(showMessage)
				{
					MessageBox.Show(ex.Message,
						"Open Cellar",
						MessageBoxButtons.OK,
						MessageBoxIcon.Error);
				}
				success = false;
			}
			finally
			{
				if(command != null)
				{
					command.Dispose();
				}
				if(connection != null)
				{
					connection.Close();
					connection.Dispose();
				}
			}
		}
	}
}
