/*=====================================================================
File: CSVLayer.cs

Summary: 

Date : Septembre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace OpenCellar.Import.Framework.Layer
{
	/// <summary>
	/// CSVLayer.
	/// </summary>
	public class CSVLayer : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button cancelButton;
		private System.Windows.Forms.Button okButton;
		private System.Windows.Forms.TextBox csvFilePath;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox separator;
		/// <summary>
		/// Variable ncessaire au concepteur.
		/// </summary>
		private System.ComponentModel.Container components = null;

		/// <summary>
		/// Initialise une instance de classe CSVLayer.
		/// </summary>
		public CSVLayer()
		{
			//
			// Requis pour la prise en charge du Concepteur Windows Forms
			//
			InitializeComponent();

			this.Location = this.PointToClient(MousePosition);
			Control line = new Control();
			line.Location = new Point(0, cancelButton.Top - 12);
			line.Size = new Size(this.Width, 1);
			line.BackColor = Color.Black;
			Controls.Add(line);
		}

		/// <summary>
		/// Obtient le dlimiteur de champ.
		/// </summary>
		public char Separator
		{
			get
			{
				if(separator.Text.Length > 0)
				{
					return(separator.Text[0]);
				}
				return(char.Parse(";"));
			}
		}

		/// <summary>
		/// Obtient l'emplacement du fichier CSV.
		/// </summary>
		public string CSVFilePath
		{
			get
			{
				return(csvFilePath.Text);
			}
		}

		/// <summary>
		/// Obtient si les informations saisies sont correctes.
		/// </summary>
		private bool IsValid
		{
			get
			{
				return((separator.Text.Length == 1)
					&& (System.IO.File.Exists(this.CSVFilePath)));
			}
		}

		/// <summary>
		/// Nettoyage des ressources utilises.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Code gnr par le Concepteur Windows Form
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		private void InitializeComponent()
		{
			this.cancelButton = new System.Windows.Forms.Button();
			this.okButton = new System.Windows.Forms.Button();
			this.csvFilePath = new System.Windows.Forms.TextBox();
			this.button1 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.separator = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// cancelButton
			// 
			this.cancelButton.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.cancelButton.Location = new System.Drawing.Point(272, 144);
			this.cancelButton.Name = "cancelButton";
			this.cancelButton.TabIndex = 9;
			this.cancelButton.Text = "Annuler";
			this.cancelButton.Click += new System.EventHandler(this.cancelButton_Click);
			// 
			// okButton
			// 
			this.okButton.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.okButton.Location = new System.Drawing.Point(176, 144);
			this.okButton.Name = "okButton";
			this.okButton.TabIndex = 7;
			this.okButton.Text = "OK";
			this.okButton.Click += new System.EventHandler(this.okButton_Click);
			// 
			// csvFilePath
			// 
			this.csvFilePath.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.csvFilePath.Location = new System.Drawing.Point(8, 40);
			this.csvFilePath.Name = "csvFilePath";
			this.csvFilePath.Size = new System.Drawing.Size(232, 21);
			this.csvFilePath.TabIndex = 1;
			this.csvFilePath.Text = "";
			// 
			// button1
			// 
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button1.Location = new System.Drawing.Point(256, 40);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(88, 23);
			this.button1.TabIndex = 3;
			this.button1.Text = "Parcourir...";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(320, 23);
			this.label1.TabIndex = 6;
			this.label1.Text = "Indiquer l\'emplacement du fichier CSV";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 80);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(232, 23);
			this.label2.TabIndex = 7;
			this.label2.Text = "Indiquer le dlimiteur de vos champs (; - ,)";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// separator
			// 
			this.separator.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.separator.Location = new System.Drawing.Point(256, 80);
			this.separator.MaxLength = 1;
			this.separator.Name = "separator";
			this.separator.Size = new System.Drawing.Size(24, 21);
			this.separator.TabIndex = 5;
			this.separator.Text = ";";
			this.separator.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// CSVLayer
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.BackColor = System.Drawing.SystemColors.Control;
			this.ClientSize = new System.Drawing.Size(362, 176);
			this.Controls.Add(this.separator);
			this.Controls.Add(this.csvFilePath);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.okButton);
			this.Controls.Add(this.cancelButton);
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "CSVLayer";
			this.Text = "Configuration";
			this.ResumeLayout(false);

		}
		#endregion

		private void okButton_Click(object sender, System.EventArgs e)
		{
			if(IsValid)
			{
				this.DialogResult = DialogResult.OK;
			}
			else
			{
				MessageBox.Show(Res.UI_INVALID_ARGS, 
					"Open Cellar",
					MessageBoxButtons.OK,
					MessageBoxIcon.Warning);
			}
		}

		private void cancelButton_Click(object sender, System.EventArgs e)
		{
			this.DialogResult = DialogResult.Cancel;
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			// Affiche la boite parcourir.
			using(OpenFileDialog ofd = new OpenFileDialog())
			{
				ofd.Filter = "Fichiers CSV (*.csv)|*.csv";

				if(ofd.ShowDialog() == DialogResult.OK)
				{
					csvFilePath.Text = ofd.FileName;
				}
			}
		}
	}
}
