/*=====================================================================
File: Step3.cs

Summary: 

Date : Septembre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using OpenCellar.Import.Framework;

namespace OpenCellar.Import.Framework
{
	/// <summary>
	/// Step3.
	/// </summary>
	public class Step3 : System.Windows.Forms.UserControl
	{
		/// <summary> 
		/// Variable ncessaire au concepteur.
		/// </summary>
		private System.ComponentModel.Container components = null;

		/// <summary>
		/// Initialise une instance de classe Step3.
		/// </summary>
		/// <param name="document">Document de travail.</param>
		public Step3(IDocument document)
		{
			// Cet appel est requis par le Concepteur de formulaires Windows.Forms.
			InitializeComponent();

			// TODO: ajoutez les initialisations aprs l'appel  InitializeComponent
			this.document = document;

			this.document.ProgressChanged+=new EventHandler(OnProgressChanged);
			rows = this.Document.Rows.Count;
			label2.Text = "L'assistant effectue les oprations demandes.\nL'importation peut durer plusieurs minutes...";
		}
		
		private int rows = 0;

		private System.Windows.Forms.Label label2;
		private ProgressBar progressBar;

		private IDocument document = null;

		/// <summary>
		/// Obtient une rfrence vers le document de travail.
		/// </summary>
		private IDocument Document
		{
			get
			{
				return(this.document);
			}
		}

		private int percent = 0;

		/// <summary>
		/// Obtient ou dfinit le pourcentage d'avancement
		/// </summary>
		private int Percent
		{
			get
			{
				return(this.percent);
			}
			set
			{
				if(this.percent != value)
				{
					this.percent = value;
					this.progressBar.Value = value;
					System.Windows.Forms.Application.DoEvents();
				}
			}
		}

		/// <summary> 
		/// Nettoyage des ressources utilises.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Code gnr par le Concepteur de composants
		/// <summary> 
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas 
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		private void InitializeComponent()
		{
			this.label2 = new System.Windows.Forms.Label();
			this.progressBar = new OpenCellar.Import.Framework.ProgressBar();
			this.SuspendLayout();
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 64);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(464, 40);
			this.label2.TabIndex = 4;
			this.label2.Text = "L\'assistant effectue les oprations demandes..";
			// 
			// progressBar
			// 
			this.progressBar.Location = new System.Drawing.Point(16, 120);
			this.progressBar.Name = "progressBar";
			this.progressBar.Size = new System.Drawing.Size(464, 23);
			this.progressBar.TabIndex = 5;
			this.progressBar.Value = 0;
			// 
			// Step3
			// 
			this.Controls.Add(this.progressBar);
			this.Controls.Add(this.label2);
			this.Name = "Step3";
			this.Size = new System.Drawing.Size(504, 264);
			this.ResumeLayout(false);

		}
		#endregion

		private void OnProgressChanged(object sender, EventArgs e)
		{
			double rowIndex = ((IRow)sender).RowIndex + 1;
			double per = Math.Ceiling((rowIndex / (double)this.rows) * 100.0f);
			Percent = Convert.ToInt32(per); 
			
		}
	}
}
