/*=====================================================================
File: ExternalConnectorInfo.cs

Summary: 

Date : Septembre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;

namespace OpenCellar.Import.Framework
{
	/// <summary>
	/// ExternalConnectorInfo.
	/// </summary>
	public class ExternalConnectorInfo
	{
		/// <summary>
		/// Initialise une instance de classe ExternalConnectorInfo.
		/// </summary>
		/// <param name="factory"></param>
		public ExternalConnectorInfo(Type factory)
		{
			// Vrifie les parametres
			if(factory == null)
			{
				throw new ArgumentNullException("factory");
			}

			if (factory.GetInterface("IWindowsDocumentFactory") == null)
			{
				throw new ArgumentException("factory doit implmenter IWindowsDocumentFactory.");
			}

			this.type = factory;
		}

		private Type type = null;

		/// <summary>
		/// Renvoit la fabrique de document.
		/// </summary>
		/// <returns></returns>
		public IWindowsDocumentFactory CreateFactory()
		{
			IWindowsDocumentFactory factory = null;
			try
			{
				factory = (IWindowsDocumentFactory)Activator.CreateInstance(this.type);
			}
			catch(Exception loadException)
			{
				System.Diagnostics.Trace.WriteLine("ExternalConnectorInfo::CreateFactory\n");
				System.Diagnostics.Trace.WriteLine(loadException.ToString());
			}

			return(factory);
		}
	}
}
