/*=====================================================================
File: IColumn.cs

Summary: 

Date : Septembre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;
using System.Text;

namespace OpenCellar.Import.Framework
{
    public interface IColumn
    {
        /// <summary>
        /// Procde au mapping donne brute -> objet vin.
        /// </summary>
        /// <param name="wine">Vin cible.</param>
        /// <param name="row">Ligne d'importation.</param>
        /// <returns>Succs de l'opration.</returns>
        bool Process(OpenCellar.Framework.Core.Wine wine, IRow row);

        /// <summary>
        /// Obtient le nom affiche de la colonne.
        /// </summary>
        string Name { get; }

        /// <summary>
        /// Obtient la priorit de la colonne.
        /// </summary>
        int Priority { get;}

        /// <summary>
        /// Obtient ou dfinit l'index de la source.
        /// </summary>
        int Index { get;set;}

        /// <summary>
        /// Cre une copie de la colonne.
        /// </summary>
        /// <returns></returns>
        IColumn Clone();
    }
}
