/*=====================================================================
File: IColumnCollection.cs

Summary: 

Date : Septembre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;
using System.Text;

namespace OpenCellar.Import.Framework
{
    public interface IColumnCollection
    {
        /// <summary>
        /// Ajoute une colonne en fin de liste.
        /// </summary>
        /// <param name="column"></param>
        void Add(IColumn column);

        /// <summary>
        /// Renvoit si la colonne est prsente dans la liste.
        /// </summary>
        /// <param name="column"></param>
        /// <returns></returns>
        bool Contains(IColumn column);

        /// <summary>
        /// Supprime la colonne spcifie.
        /// </summary>
        /// <param name="column"></param>
        void Remove(IColumn column);

        /// <summary>
        /// Obtient la colonne spcifie en index.
        /// </summary>
        /// <param name="index">Index de la colonne.</param>
        /// <returns>IColumn correspondante</returns>
        IColumn this[int index] { get;}

        /// <summary>
        /// Obtient le nombre de colonnes prsentes dans la liste.
        /// </summary>
        int Count { get;}

        /// <summary>
        /// Se produit lorsque la liste subit un changement.
        /// </summary>
        event EventHandler ListChanged;
    }
}
