/*=====================================================================
File: RowCollection.cs

Summary: 

Date : Septembre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;
using System.Collections;
using System.Text;

namespace OpenCellar.Import.Framework
{
    public class RowCollection : IRowCollection
    {    
        /// <summary>
        /// Initialise une instance de la classe RowCollection.
        /// </summary>
        public RowCollection()
        { 
            
        }

        private ArrayList list = new ArrayList();

        /// <summary>
        /// Ajoute une ligne  la collection.
        /// </summary>
        /// <param name="row"></param>
        public void Add(IRow row)
        {
            // Vrifie le parametre
            if (row == null)
            {
                throw new ArgumentNullException("row");
            }

            this.list.Add(row);
        }

        /// <summary>
        /// Supprime la ligne de la liste.
        /// </summary>
        /// <param name="row"></param>
        protected void Remove(IRow row)
        {
            // Vrifie le parametre
            if (row == null)
            {
                throw new ArgumentNullException("row");
            }

            this.list.Remove(row); 
        }

        /// <summary>
        /// Recalcul les liens.
        /// </summary>
        protected void ReorderIndex()
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Obtient la ligne spcifie en index.
        /// </summary>
        /// <param name="index">Index de la ligne.</param>
        /// <returns>IRow correspondante</returns>
        public IRow this[int index]
        {
            get
            {
                if ((index > -1)
                    && (index < this.list.Count))
                {
                    return ((IRow)this.list[index]);
                }

                throw new ArgumentOutOfRangeException("index");
            }
        }

        /// <summary>
        /// Obtient le nombre de lignes prsent dans la liste.
        /// </summary>
        public int Count
        {
            get
            {
                return (this.list.Count);
            }
        }
    }
}
