/*=====================================================================
File: UIUtility.cs

Summary: 

Date : Septembre 2007

Origin: Open Cellar ! Project

Revision:

Aut: Matthieu DUCROCQ

---------------------------------------------------------------------
Copyright (C) Matthieu DUCROCQ
=====================================================================*/
using System;
using System.Windows.Forms;

namespace OpenCellar.Import.Framework
{
	/// <summary>
	/// UIUtility.
	/// </summary>
	public class UIUtility
	{
		/// <summary>
		/// Cache tous les controles enfants.
		/// </summary>
		/// <param name="ctl">Controle container.</param>
		public static void HideChildControls(Control ctl)
		{
			if(ctl == null)
			{
				throw new ArgumentNullException("ctl");
			}

			for (int i = 0; i < ctl.Controls.Count; i++)
			{
				ctl.Controls[i].Visible = false;
			}
		}

		/// <summary>
		/// 
		/// </summary>
		/// <param name="wait"></param>
		/// <param name="form"></param>
		public static void SetWaitCursor(bool wait, Form form)
		{
			if(form == null)
			{
				throw new ArgumentNullException("form");
			}

			form.Cursor = (wait == true ? Cursors.WaitCursor : Cursors.Default);
			System.Windows.Forms.Application.DoEvents();
		}

		public static void DoEvents()
		{
			System.Windows.Forms.Application.DoEvents();
		}
	}
}
